% AM_5_mode_Octave.m -           ,     . 
%    Octave       
%  MATLAB,       fsolve( ).
%    ,      
%      c      ( ). 
%    .       .
%        4AM100L6   . 
%    : IM_fun_Octave (.: IM_fun_Octave.m). 
clear % -   
global r_1 r_2 L_1 L_2 M U_m W W_p   r_my_a I_1 I_2 I_my_a I_my_r U_1 s nac
%   ,   ,   
U_baz=220; I_baz = 5.6; % -  ()  , []
P_baz = 3*U_baz*I_baz ; % -  , []
W_baz = 2*pi*1000/60;   % -    (  ), [/]
P_2_nom = 2200;   % -    []
EFI_nom = 0.81;   % -  .  
%cos_Fi  = 0.73;  % -  .  
r_1 = 0.07275; r_2 = 0.05041; L_1 = 0.07804; L_2 = 0.1442; M= 0.8185;  % [..] 
W=1;          % -  
U_m=   1 ;    % -  ,    
W_p=0.95975;  % -        P_mex=P_2_,[..] 
x_1=0.96;     % -   , [..]
x_2=1.57893;  % -   , []

i_plot=0; % -         plot
  
% : "y " -      ; "n" -  .  
reply_saturation = input('Consider  saturation? (y/n): ','s');
if strcmp(reply_saturation,'y')
    nac = 'saturation';        %       . 
else
   nac = 'Without_saturation'; %    . 
end
% : "5" -       ; "n" -     . 
reply_operating_modes  = input('Five operating modes (5) or No-load operating mode (n)? (5/n): ','s');
if strcmp(reply_operating_modes,'5') %       .
    W_p_start = 2.5; delta_W_p = -0.0041 ; W_p_stop = -0.5;       % -   .
else  
    W_p_start = 1.0055; delta_W_p = -0.0005; W_p_stop = 0.9995;   % -   . 
end
   
 for W_p = W_p_start : delta_W_p: W_p_stop  % -   
%      
  x=fsolve(@IM_fun_Octave,[x_1, x_2], optimset('Display','off'));
    x_1 = x(1);     x_2 = x(2); %  -     .
%    , ,    (..).
  u_1_abs = abs(U_1);       % -   .
  i_1_abs = abs(I_1);       % -   .
  i_2_abs = abs(I_2);       % -   . 
  i_my_a_abs = abs(I_my_a); % -    .
  i_my_r_abs = abs(I_my_r); % -    .
  i_my_abs   =  abs(I_my_a+I_my_r);               % -   .
  P_el = real(U_1.*  I_1')            ;           % -   .
  delta_P_el_1 = (i_1_abs.^2)*r_1     ;           % -     (..).
  delta_P_magn = (i_my_a_abs.^2)*r_my_a ;         % -     (..).
  P_e_magn = P_el  - delta_P_el_1 - delta_P_magn; % -  .
  delta_P_el_2 = (i_2_abs.^2)*r_2       ;         % -     (..).
  P_mex_ =  P_e_magn - delta_P_el_2 ;  % -         (..). "_" - . 
  delta_P_mex  =  0.00295*W_p^2     ;  % 0.00295 -      .. 
  P_mex = P_mex_ - delta_P_mex ;    ;  % -     .
%  delta_P_sum = delta_P_el_1 + delta_P_magn + delta_P_el_2  + delta_P_mex;%    .
 if(s>0)                %      
    Efi = P_mex/P_el ;  % .
 else                   %     .
    Efi=P_el/P_mex   ;
 end
cosFi=cos(angle(U_1)-angle(I_1)) ;  % -  .

%          plot.
i_plot = i_plot+1;
s_plot(i_plot) = s     ;
P_el_plot(i_plot) = P_el          ;
P_e_magn_plot(i_plot) = P_e_magn  ;
P_mex_plot(i_plot) =P_mex         ; 
delta_P_mex_plot(i_plot) = delta_P_mex; 
 end

if strcmp(reply_operating_modes,'5') %     (5)    (n). 
    %      () ,    .
    pryg_x =   [ -0.1 -0.1     0.1   0.1  -0.1];  % -  
    pryg_y =  [ 0.6   -0.6    -0.6   0.6  0.6];   %      . 
    %  ,      .
    %  : 1.     2.  .   
    if strcmp(nac, 'saturation')
        s_g_psevdog_x = [-0.58  -0.58] ; 
    else
        s_g_psevdog_x = [-0.44  -0.44] ; 
    end
        s_g_psevdog_y = [ 0.1   -6];
 %  ,         .     
    s_ad_prtvbkl_x = [1      1] ; 
    s_ad_prtvbkl_y = [4.2   -6] ;
 %       .
 %      Octave    "...  %"   'LineWidth'.
        plot(s_plot, P_el_plot.*(P_baz/P_2_nom),     '-',  ... %  'LineWidth', 2, ...  
        s_plot, P_e_magn_plot.*(P_baz/P_2_nom),  '-',  ... %  'LineWidth', 2, ...
        s_plot, P_mex_plot.*(P_baz/P_2_nom),        '-',   ... %  'LineWidth', 2, ...
        s_g_psevdog_x,  s_g_psevdog_y,                '--',  ... %  'LineWidth', 1.5, ...
        s_ad_prtvbkl_x , s_ad_prtvbkl_y,                  '--',  ... %  'LineWidth', 1.5, ...
        pryg_x,    pryg_y,  '--',  'LineWidth', 1.5)
        %   ,     () Octave. 
        set (gca , 'fontsize' ,15)  % -    Octave - 15 .   MATLAB -  .   
        title({'Electric, Electromagnetic & ';'Shaft mechanical power (pu) vs slip'} ) % -  . 
        xlabel('slip, pu')        % -   "" (). 
        ylabel('P/P_n_o_m, pu')   % -   "y" (   ..).    .
        legend( '1.Electric  power',  '2.Electromagnetic power', '3.Shaft mechanical power', 'Location','northwest') % - . 
else
    if strcmp(nac, 'saturation')   %    .  
     %  ,        
     %        .  
         s_g_XX_x =  [-3.275/1000    -3.275/1000 ]; 
         s_g_XX_y =  [ 0.01          -0.2        ];
        % ,           .  
        s_ad_XX_x =  [1/10000       1/10000];  
        s_ad_XX_y =  [0.11         -0.2    ];
   else  %     .
        s_g_XX_x =  [-4.49/1000    -4.49/1000];   
        s_g_XX_y =  [ 0.014        -0.2      ];
        s_ad_XX_x = [1.67448/10000        1.67448/10000  ]; 
        s_ad_XX_y = [0.15          -0.2      ] ;
   end
    %      .
     %      Octave    "...  %"   'LineWidth'.
        plot(s_plot, P_el_plot.*(P_baz/P_2_nom),     ...  % 'LineWidth', 2, ...  
        s_plot, P_e_magn_plot.*(P_baz/P_2_nom),  ...  % 'LineWidth', 2, ...
        s_plot, P_mex_plot.*(P_baz/P_2_nom),       ...  % 'LineWidth', 2, ...
        s_g_XX_x,  s_g_XX_y, '--',                         ...  % 'LineWidth', 1.5, ...
        s_ad_XX_x, s_ad_XX_y , '--', 'LineWidth',1.5)
        %   ,     () Octave 
        set (gca , 'fontsize' ,15)  % -    Octave - 15 .    MATLAB -   . 
        title({'Electric, Electromagnetic & Shaft mechanical';' power (pu) vs slip. No-load operating mode'} ) % -   
        xlabel('slip, pu')        % -   "" (). 
        ylabel('P/P_n_o_m, pu')   % -   "y" (   ..).    
        legend( '1.Electric  power',  '2.Electromagnetic power', '3.Shaft mechanical power', 'Location','northwest') % -  
end    
grid on  % -  
